#
# Gas Ideal Portal
# Author Ing. Ulises carreón
# Realhost S.A de C.v
# Branches Controller
#
class BranchesController < ApplicationController
  before_action :authenticate_user!

  def index
    @branches = Branch.all 
    @certificados = Certificate.all 
    @folios = Folio.all 
  end
  
  def show
    @certificados = Certificate.all 
    @folios = Folio.all 
    @branch = Branch.find(params[:id])
  end

  def update
    begin
        branch = Branch.find params[:id]
        if params[:accept_certificates]
            branch.update name: params[:name], branchcode: params[:branchcode], email: params[:email], phone: params[:phone], address1: params[:calle], address2: params[:numero_interno], address3: params[:cp], address4: params[:colonia], address5: params[:estado], address6: params[:pais], certificado: params[:certificado], folio: params[:folio]
        else
            branch.update name: params[:name], branchcode: params[:branchcode], email: params[:email], phone: params[:phone], address1: params[:calle], address2: params[:numero_interno], address3: params[:cp], address4: params[:colonia], address5: params[:estado], address6: params[:pais],certificado: nil, folio: nil
        end
        branch.save
        flash[:notice] = "Sucursal  actualizada correctamente."
        redirect_to action: 'index'  
    rescue Exception => e 
          puts e.message
          flash[:alert] = "Error al actualizar la sucursal."
          redirect_to action: 'index'  
    end
  end

  def create
    begin
        branch = nil
        if params[:accept_certificates]
            branch = Branch.new name: params[:name], branchcode: params[:branchcode], email: params[:email], phone: params[:phone], address1: params[:calle], address2: params[:numero_interno], address3: params[:cp], address4: params[:colonia], address5: params[:estado], address6: params[:pais], certificado: params[:certificado], folio: params[:folio]
        else
            branch = Branch.new name: params[:name], branchcode: params[:branchcode], email: params[:email], phone: params[:phone], address1: params[:calle], address2: params[:numero_interno], address3: params[:cp], address4: params[:colonia], address5: params[:estado], address6: params[:pais], certificado: nil, folio: nil
        end
        branch.save
        flash[:notice] = "Sucursal creada correctamente."
        redirect_to action: 'index'  
    rescue Exception => e 
          flash[:alert] = "Error al crear la sucursal."
          redirect_to action: 'index'  
    end
  end
end