#
# Gas Ideal Portal
# Author Ing. Ulises carreón
# Realhost S.A de C.v
# Debtors Controller
#
class DebtorsController < ApplicationController
  before_action :authenticate_user!

  def index
    @debtors = Debtor.all
    @usos    = Uso.all
    @metodos = MetodoPago.all
    @formas  = Formapago.all
  end

  def show
    @usos    = Uso.all 
    @metodos = MetodoPago.all
    @formas  = Formapago.all
    @debtor  = Debtor.find(params[:id])
  end


  def update
    begin
        debtor = Debtor.find_by(id: params[:id])
        if Debtor.exists?(:rfc => params[:rfc]) and params[:rfc] != 'XAXX010101000' and params[:rfc] != 'XEXX010101000' and debtor.rfc != params[:rfc]
          flash[:alert] = "El RFC que intentas registrar ya existe."
          redirect_to action: 'index'  
          return 
        end
        debtor.update(name: params[:name], debtorno: params[:debtorno], razon_social: params[:razon_social], rfc: params[:rfc], email: params[:email], phone: params[:phone], address1: params[:calle], address2: params[:numero_interno], address4: params[:colonia], address7: params[:ciudad], address8: params[:estado], address9: params[:pais], address10: params[:cp], uso_cfdi: params[:uso_cfdi], metodo_pago: params[:metodo_pago], forma_pago: params[:forma_pago], descuento: params[:descuento], cuenta: params[:cuenta])
        flash[:notice] = "Cliente  actualizado correctamente."
        redirect_to action: 'index'  
    rescue Exception => e 
          puts e.message
          flash[:alert] = "Error al actualizar el cliente"
          redirect_to action: 'index'  
    end
  end
  
  def create
      begin
        if Debtor.exists?(:rfc => params[:rfc]) and params[:rfc] != 'XAXX010101000' and params[:rfc] != 'XEXX010101000'
          flash[:alert] = "El RFC que intentas registrar ya existe."
          redirect_to action: 'index'  
          return 
        end
        debtor              = Debtor.new 
        debtor.name         = params[:name]
        debtor.razon_social = params[:razon_social]
        debtor.rfc          = params[:rfc]
        debtor.email        = params[:email]
        debtor.phone        = params[:phone]
        debtor.address1     = params[:calle]
        debtor.address2     = params[:numero_interno]
        debtor.address4     = params[:colonia]
        debtor.address7     = params[:ciudad]
        debtor.address8     = params[:estado]
        debtor.address9     = params[:pais]
        debtor.address10    = params[:cp]
        debtor.uso_cfdi     = params[:uso_cfdi]
        debtor.metodo_pago  = params[:metodo_pago]
        debtor.forma_pago   = params[:forma_pago]
        debtor.cuenta       = params[:cuenta]
        debtor.descuento    = params[:descuento]
        debtor.save
        debtor.debtorno     = debtor.id.to_s.rjust 5, '0'
        debtor.save
        flash[:notice] = "Cliente creado correctamente."
        redirect_to action: 'index'  
      rescue Exception => e 
          puts e.message
          flash[:alert] = "Error al crear el cliente"
          redirect_to action: 'index'  
      end
  end

  def getData
    debtor = Debtor.find_by debtorno: params[:id]
    render json: {uso_cfdi: debtor.uso_cfdi, metodo_pago: debtor.metodo_pago, forma_pago: debtor.forma_pago}
  end

end
