#
# Gas Ideal Portal
# Author Ing. Erik Camacho
# Realhost S.A de C.v
# Devices Controller
#
class DeviceController < ApplicationController
  before_action :authenticate_user!
  def index
  	devicesdata = RestClient.get ENV['API_HOST']+'/device/get', {content_type: :json, accept: :json}
  	if devicesdata.code != 200
  		redirect_to action: 'index'
  	end
  	@devices  = JSON.parse devicesdata.body
  	unitsdata = RestClient.get ENV['API_HOST']+'/unit/get', {content_type: :json, accept: :json}
  	if unitsdata.code != 200
  		redirect_to action: 'index'
  	end
  	@units = JSON.parse unitsdata.body
  end

  def create
    json               = Hash.new
  	json[:name]        = params[:name]
  	json[:uuid_mobile] = params[:uuid_mobile]
  	json[:unit_id]     = params[:unit]
    RestClient.post ENV['API_HOST']+'/device/save', json.to_json, {content_type: :json, accept: :json}
    redirect_to action: "index"
  end

  def update
    json               = Hash.new
    json[:id]          = params[:id]
    json[:name]        = params[:name]
    json[:uuid_mobile] = params[:uuid_mobile]
    json[:unit_id]     = params[:unit]
    RestClient.post ENV['API_HOST']+'/device/save', json.to_json, {content_type: :json, accept: :json}
    redirect_to action: "index"
  end

  def show
    devicesdata = RestClient.get ENV['API_HOST']+'/device/get/'+params[:id], {content_type: :json, accept: :json}
    if devicesdata.code != 200
      redirect_to action: 'index'
    end
    @device   = JSON.parse devicesdata.body
    unitsdata = RestClient.get ENV['API_HOST']+'/unit/get', {content_type: :json, accept: :json}
    if unitsdata.code != 200
      redirect_to action: 'index'
    end
    @units = JSON.parse unitsdata.body
  end
end