require 'rest-client'
require 'json'

class ReportsController < ApplicationController
  before_action :authenticate_user!
  #before_action :checkrole
  
  def index
  	@debtors = Debtor.order(:name).all
  end

  def consult_voucher
    begin 
    	responseVouchers = RestClient.post ENV['API_HOST']+'/consult', params.to_json, {content_type: :json}
      @collection = JSON.parse(responseVouchers.body)['collection']
    rescue RestClient::ExceptionWithResponse => err
      puts err
    end
  end

  def consult_lts
    begin
      puts params.to_json
      response   = RestClient.post ENV['API_HOST']+'/lts', params.to_json, {content_type: :json}
      @result    = JSON.parse response.body
      @startdate = params[:inicial]
      @endate    = params[:final]
      if @result["facturados"] == nil
        @result["facturados"] = 0
      end
      if @result["consumidos"] == nil
        @result["consumidos"] = 0
      end
      @sum = @result["consumidos"].to_i - @result["facturados"].to_i
      @sumfact = @result["facturados1"] + @result["facturados5"] + @result["facturados10"] + @result["facturados20"] + @result["facturados50"]
      @sumcons = @result["consumidos1"] + @result["consumidos5"] + @result["consumidos10"] + @result["consumidos20"] + @result["consumidos50"] 
    rescue RestClient::ExceptionWithResponse => err
      puts err
    end
  end

  def consult_invoice
    puts params 
    @collection = Invoice.select('*').where 'created_at >= ? and created_at <= ?', params[:inicial], params[:final] + " 23:59:59"
    if params[:invoicestatus] != 'all'
      @collection = @collection.where invoice_status: params[:invoicestatus]
    end
    if params[:paymentstatus] != 'all'
      @collection = @collection.where paid_status: params[:paymentstatus]
    end
    if params[:discount] == 'withoutdiscounts'
      @collection = @collection.where discount: 0
    end
    if params[:discount] == 'one'
      @collection = @collection.where discount: params[:onediscountvalue]
    end
    if params[:discount] == 'range'
      @collection = @collection.where "discount >= ? AND discount <= ?", params[:rangediscount1], params[:rangediscount2]
    end
    whereString = ''
    params[:clientes].each do |client_id|
      if whereString == ''
        whereString = "debtor=#{client_id}"
      else
        whereString = "#{whereString} OR debtor=#{client_id}"
      end
    end
    @collection = @collection.where whereString
  end

  def check_voucher_status
    if params[:folio] == "" or params[:folio] == nil
      @result = ""
      @folio  = ""
      return
    end
    @folio    = params[:folio].gsub " ", ""
    puts @folio
    response  = RestClient.get ENV['API_HOST']+'/uuid/transaction/'+@folio, {content_type: :json}
    @response = JSON.parse response.body
    @debtor   = Debtor.where(id: @response["debtor_id"]).first
  end
end
