#
# Gas Ideal Portal
# Author Ing. Erik Camacho
# Realhost S.A de C.v
# Unit Controller
#
class UnitController < ApplicationController
  before_action :authenticate_user!
  def index
  	unitsdata = RestClient.get ENV['API_HOST']+'/unit/get', {content_type: :json, accept: :json}
  	if unitsdata.code != 200
  		redirect_to action: 'index'
  	end
  	@units = JSON.parse unitsdata.body
  	centralsdata = RestClient.get ENV['API_HOST']+'/central/get', {content_type: :json, accept: :json}
  	if centralsdata.code != 200
  		redirect_to action: 'index'
  	end
  	@centrals = JSON.parse centralsdata.body
  end

  def create
  	json              = Hash.new
  	json[:name]       = params[:name]
  	json[:central_id] = params[:central]
    RestClient.post ENV['API_HOST']+'/unit/save', json.to_json, {content_type: :json, accept: :json}
    redirect_to action: "index"
  end

  def update
    json              = Hash.new
    json[:id]         = params[:id]
    json[:name]       = params[:name]
    json[:central_id] = params[:central]
    RestClient.post ENV['API_HOST']+'/unit/save', json.to_json, {content_type: :json, accept: :json}
    redirect_to action: "index"
  end

  def show
    unitsdata = RestClient.get ENV['API_HOST']+'/unit/get/'+params[:id], {content_type: :json, accept: :json}
    if unitsdata.code != 200
      redirect_to action: 'index'
    end
    @unit = JSON.parse unitsdata.body
    centralsdata = RestClient.get ENV['API_HOST']+'/central/get', {content_type: :json, accept: :json}
    if centralsdata.code != 200
      redirect_to action: 'index'
    end
    @centrals = JSON.parse centralsdata.body
  end
end