#
# Gas Ideal Portal
# Author Ing. Ulises carreón
# Realhost S.A de C.v
# Voucher Controller
# 
require 'rest-client'
require 'json'

class VoucherController < ApplicationController
  before_action :authenticate_user!
  #skip_before_action :verify_authenticity_token
  #before_action do |c| 
  #  checkrole ['admin', 'root', 'voucher']
  #end
  include VoucherHelper
  def index
    begin 
      responseOrders = RestClient.get ENV['API_HOST']+'/getOrders', {content_type: :json, accept: :json}
      if responseOrders.code == 200
         dataString = JSON.parse(responseOrders.body)
         @orders = dataString["data"]
         flash[:notice] = "Mostrando órdenes realizadas."
      else
         flash[:alert] = "No se puede obtener las ordenes."
      end
    rescue RestClient::ExceptionWithResponse => err
       parsed = JSON.parse(err.response)
       flash[:alert] = parsed["message"]
    end
  end

  def req
  end

  def activate
    session[:vouchers] = params[:vouchers]
    session[:total]    = params[:total]
    @Clients           = Debtor.all
    @Fiscals           = Fiscal.first
    @metodos           = MetodoPago.all
    @formas            = Formapago.all
    @usos              = Uso.all
    @Branches          = Branch.where.not(certificado: nil) 
  end

  def activate_vouchers(facturar=true)
    #params = session[:parameters]
    tmp = session[:parameters]
    session[:parameters] = params
    begin
      uuidValues = Hash.new
      session[:vouchers].each do |uuid| 
        uuid = uuid.split(': ')[1]
        uuidValues["#{uuid}"] = 'enabled'
      end
      debtor = Debtor.find_by debtorno: params["client"]
      if debtor == nil
        debtor = Debtor.find_by debtorno: tmp["client"]
      end
      config = Cofig.first
      logger.debug "++++++++"
      logger.debug ""+{uuids: uuidValues, debtor: debtor.id, prodoser: config.code_article, code_measure: config.code_mesure, price: config.price, discount: debtor.descuento}.to_json
      logger.debug "+++++++++++++++++++++++++++++++++++++++++++"
      data = RestClient::Request.execute(
        :method  => :post, 
        :url     => ENV['API_HOST']+'/uuid/activate',
        :payload => {uuids: uuidValues, debtor: debtor.id, prodoser: config.code_article, code_measure: config.code_mesure, price: config.price, discount: debtor.descuento},
        :timeout => 2048,
        :headers => {content_type: :json, accept: :json})
      #data = RestClient.post ENV['API_HOST']+'/uuid/activate', {uuids: uuidValues, debtor: debtor.id, prodoser: config.code_article, code_measure: config.code_mesure, price: config.price, discount: debtor.descuento}.to_json, {content_type: :json, accept: :json}
      @rescueData = data
      if not facturar
        flash[:notice] = "Los vales fueron activados correctamente sin factura."
        redirect_to action: 'quantity'
        return
      end
      if data.code == 200
        params = tmp
        #data = firebase.set('vales/', uuidValues)
        type = params["detailed"] == 'on' ? 'Detallado' : 'Resumen'
        body = JSON.parse data.body
        invoiceData = getInvoiceData(params["client"], params["branch"], params["uso"], params["metodo"], params["forma"], uuidValues, type, body["transaction_identifier"])
        logger.debug " ------------------------------- INVOICE DATA ------------------------------- "
        logger.debug invoiceData.to_json        
        data = RestClient.post ENV['API_HOST']+'/invoice/make', invoiceData.to_json, {content_type: :json, accept: :json}
        if data.code == 200
          data = JSON.parse(data.body)
          aTransaction                 = ActivationTransaction.new
          aTransaction.debtor          = debtor.id
          aTransaction.xml             = data["xml"]
          aTransaction.branch          = params["branch"]
          aTransaction.uuid            = data["uuid"]
          aTransaction.cadena_original = data["cadena"]
          aTransaction.serie           = invoiceData[:folio_serie]
          aTransaction.folio           = invoiceData[:folio_initial]
          aTransaction.id_user         = current_user.id
          aTransaction.discount        = debtor.descuento
          aTransaction.price           = invoiceData[:price]
          aTransaction.total           = data["total"]
          aTransaction.subtotal        = data["subtotal"]
          aTransaction.iva             = data["iva"]
          aTransaction.cfdi_use        = invoiceData[:client_uso_cfdi]
          aTransaction.payment_method  = invoiceData[:client_payment_method]
          aTransaction.payment_form    = invoiceData[:client_payment_form]
          aTransaction.detailed        = params["detailed"] == 'on'
          aTransaction.occliente       = params["occliente"]
          aTransaction.observaciones   = params["observaciones"]
          aTransaction.save
          datauuida                          = Hash.new
          datauuida[:transaction_identifier] = body["transaction_identifier"]
          datauuida[:id_invoice]             = aTransaction.id
          datauuida[:code_article]           = invoiceData[:code_article]
          datauuida[:code_mesure]            = invoiceData[:code_mesure]
          datauuida[:price]                  = invoiceData[:price]
          datauuida[:discount]               = debtor.descuento
          RestClient.post ENV['API_HOST']+'/uuid/updateTransaction', datauuida.to_json, {content_type: :json}
          flash[:notice] = data["message"]
          flash[:linkid] = aTransaction.id
          redirect_to action: 'quantity'
        else
          flash[:alert] = "Error #{data.code}: #{data.message}."
          redirect_to action 'quantity'
        end
      else
        flash[:alert] = "Error #{data.code}: #{data.message}."
        redirect_to action: 'quantity'
      end
    rescue RestClient::ExceptionWithResponse => err
      #logger.debug "VoucherRollback starts..."
      #body = JSON.parse @rescueData.body
      #logger.debug body["transaction_identifier"]
      #res = RestClient.post ENV['API_HOST']+'/uuid/rollback', {ta: body["transaction_identifier"]}.to_json, {content_type: :json}
      #logger.debug res
      #logger.debug "VoucherRollback ends!"
      message = "Ocurrió un error al facturar, los vales no fueron activados. Por favor, inténtelo de nuevo"
      begin
        json = JSON.parse err.response
        message = json["message"]
      rescue
        puts "RESCUEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE"
      end
      flash[:alert] = message
      redirect_to action: 'quantity'
      logger.debug err
    end
  end

  def order
  end

  def request_vouchers
    begin
      responseRequest = RestClient.post ENV['API_HOST']+'/order', params.to_json, {content_type: :json, accept: :json}
      if responseRequest.code == 202
        parsedBody = JSON.parse(responseRequest.body)
        flash[:notice] = parsedBody["message"]
        redirect_to action: 'index'
      else
        flash[:notice] = "Error al solicitar el pedido."
        redirect_to action: 'index'
      end
    rescue RestClient::ExceptionWithResponse => err
       logger.debug err
       parsed = JSON.parse(err.response)
       flash[:alert] = parsed["message"]
       redirect_to action: 'index'  
    end 
  end

  def create
    begin
      responseRequest = RestClient.post ENV['API_HOST']+'/voucher', {'quantity' => params[:cantidad]}.to_json, {content_type: :json, accept: :json}
      parsed = JSON.parse(responseRequest.body)
      flash[:notice] = "Solicitud creada correctamente."
      redirect_to action: 'index'
    rescue RestClient::ExceptionWithResponse => err
       parsed = JSON.parse(err.response)
       flash[:alert] = parsed["message"]
       redirect_to action: 'index'  
    end        
  end

  def confirmation
    if not params[:facturar] == 'on'
      activate_vouchers false
      return
    end
    config      = Cofig.first
    @debtor     = Debtor.find_by debtorno: params[:client]
    descuento   = @debtor.descuento.to_f / 100
    @price      = (config.price.to_f * 1.16 - descuento) / 1.16
    @branch     = Branch.find params[:branch]
    @total      = session[:total]
    @date       = Time.now.to_s :long
    @type       = params[:detailed] == 'on' ? :Detallado : :Resumen
    @totalprice = '%.2f' % (@total.to_i * @price.to_f * 1.16)
    @totpricewi = '%.2f' % (@total.to_i * @price.to_f)
    if @type == :Detallado
      @uuidValues = {'1' => 0, '5' => 0, '10' => 0, '20' => 0, '50' => 0}
      session[:vouchers].each do |uuid| 
        litros = uuid.split(' litros: ')[0]
        @uuidValues[litros] += 1
      end
    end
    session[:parameters] = params
  end

end