module ReportsHelper
	def getClientName(id)
		debtor = Debtor.find_by id: id
		if debtor == nil
			return ''
		else
			return debtor.name
		end
	end

	def getVoucherStatus(status)
		if status == "enabled"
			return "Activado"
		elsif status == "disabled"
			return "Desactivado"
		elsif status == "blocked"
			return "Bloqueado"
		elsif status == "used"
			return "Consumido"
		end
	end

	def getPrecioLitro(id)
		if not id or id == 0
			return "---"
		end
		invoice = Invoice.find id
		return "$ #{invoice.price}"
	end

	def getDiscount(id)
		if not id or id == 0
			return "---"
		end
		invoice = Invoice.find id
		return "¢ #{invoice.discount}"
	end

	def getInvoiceNumberWithId(id)
		if not id or id == 0
			return "---"
		end
		invoice = Invoice.find id
		return link_to "#{invoice.serie}#{invoice.folio}", {controller: "invoice", action: "show", id: invoice}, target: "_blank"
	end

	def getPdfWithId(id)
		if not id or id == 0
			return ""
		end
		return link_to (content_tag :i, '', class: "fa fa-file-pdf-o"), "/invoice/download_pdf?id=#{id}"
	end

	def getXMLWithId(id)
		if not id or id == 0
			return ""
		end
		return link_to (content_tag :i, '', class: "fa fa-file-code-o"), "/invoice/download_xml?id=#{id}"
	end

	def sendInvoiceThroughEmailWithId(id) 
		if not id or id == 0
			return ""
		end
		return link_to (content_tag :i, '', class: "fa fa-reply"), "javascript:void(0);", class: "mail", data: {id: id}
	end

	def getInvoiceStatus(status)
		if status == "active"
			return "Activo"
		else 
			return "Cancelado"
		end
	end

	def getPaymentStatus(status)
		if status == "paid"
			return "Pagada"
		else 
			return "Pendiente"
		end
	end
end