module VoucherHelper
	def getStatus(status)
		case status
		when 'unauthorized'
			return 'No autorizado'
		when 'authorized'
			return 'Autorizado'
		when 'generating'
			return 'Generando PDF'
		when 'created'
			return 'PDF Creado'
		when 'error'
			return 'ERROR'
		else
			return '-- Sin estado --'
		end
	end

	def quantity
	end

	def getInvoiceData(id_client, id_branch, cfdi_use, payment_method, payment_form, vouchers, type, transaction_identifier)
		data = Hash.new
		
		#Getting models section
		debtor      = Debtor.find_by debtorno: id_client
		branch      = Branch.find id_branch
		certificate = Certificate.find branch.certificado 
		fiscal      = Fiscal.first
		config      = Cofig.first
		
		#JSON generation section
		data[:client_name]            = debtor.name
		data[:client_rfc]             = debtor.rfc
		data[:client_razon_social]    = debtor.razon_social
		data[:client_uso_cfdi]        = cfdi_use
		data[:client_payment_method]  = payment_method
		data[:client_payment_form]    = payment_form
		data[:branch]                 = branch.name
		data[:branch_addr1]           = branch.address1
		data[:branch_addr2]           = branch.address2
		data[:branch_addr3]           = branch.address3
		data[:branch_addr4]           = branch.address4
		data[:branch_addr5]           = branch.address5
		data[:branch_addr6]           = branch.address6
		data[:branch_addr7]           = branch.address7
		data[:branch_addr8]           = branch.address8
		data[:branch_addr9]           = branch.address9
		data[:branch_addr10]          = branch.address10
		data[:cer_path]               = certificate.certificado
		data[:cer_key_path]           = certificate.certificadokey
		data[:cer_number]             = certificate.nocertificado
		data[:fiscal_razon]           = fiscal.razon_fiscal
		data[:fiscal_rfc]             = fiscal.rfc
		data[:fiscal_regimen]         = fiscal.regimen_fiscal
		data[:folio_initial]          = getFolio branch.folio
		data[:folio_serie]            = getSerie branch.folio
		data[:code_article]           = config.code_article
		data[:code_mesure]            = config.code_mesure
		data[:vouchers]               = vouchers
		data[:type]                   = type
		data[:transaction_identifier] = transaction_identifier
		data[:price]                  = ((config.price.to_f * 1.16) - (debtor.descuento.to_f / 100))/1.16
		return data
	end

	def getFolio(id)
		folio = Folio.find id
		f = folio.initial
		folio.initial += 1
		folio.save
		return f
	end

	def getSerie(id)
		folio = Folio.find id
		return folio.code
	end

	def getDetails(status)
		
	end
end