Rails.application.routes.draw do
  get 'users/index'
  get 'configuration/index'
  post 'configuration/update'
  get 'voucher/index'
  get 'voucher/req'
  post 'voucher/create'
  post 'voucher/getdata'
  post 'voucher/activate'
  post 'voucher/activate_vouchers'
  post 'voucher/confirmation'
  get 'voucher/quantity'
  get 'fiscal/index'
  get 'cfdi/index'
  get 'cfdi/create'
  get 'branches/index'
  post 'branches/create'
  post 'branches/update'
  get 'folios/index'
  get 'debtors/index'
  post 'debtors/update'
  get 'debtors/usos'
  post 'debtors/createuso'
  post 'debtors/get_data/:id',to: 'debtors#getData'
  get 'debtors/show/:id',     to: 'debtors#show' 
  get 'branches/show/:id',    to: 'branches#show' 
  get 'certificates/index'
  post 'certificates/create'
  post 'folios/create'
  post 'debtors/create'
  post 'fiscal/update'
  post 'fiscal/upload_photo'
  get 'home/index'
  get 'users/index'
  get 'users/show/:id', to: 'users#show'
  post 'users/create'
  post 'users/update', to: 'users#update'
  post 'voucher/request_vouchers'
  get 'voucher/order'
  get 'invoice/index'
  get 'invoice/download_xml'
  get 'invoice/download_pdf'
  post 'invoice/activate'
  post 'invoice/cancel'
  get 'invoice/pay/:id', to: 'invoice#pay'
  get 'invoice/cancellpayment/:id', to: 'invoice#cancellpayment'
  post 'invoice/mail'
  get 'invoice/show/:id', to: 'invoice#show'
  post 'invoice/masive_download'
  get 'reports/index'
  post 'reports/consult_voucher'
  post 'reports/consult_invoice'
  get 'uuid/get/:uuid', to: 'uuid#get'
  get 'unit/index'
  get 'unit/show/:id', to: 'unit#show'
  post 'unit/update'
  post 'unit/create'
  get 'device/index'
  get 'device/show/:id', to: 'device#show'
  post 'device/update'
  post 'device/create'
  get 'central/index'
  get 'central/show/:id', to: 'central#show'
  post 'central/update'
  post 'central/create'
  get 'rescue/index'
  get 'reports/check_voucher_status'
  post 'reports/check_voucher_status'
  post 'reports/consult_lts'
  devise_for :users
  root to: "voucher#index"
end
